> For the complete documentation index, see [llms.txt](https://docs.ox.security/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ox.security/api-documentation/api-reference/api--scan/mutations/update-custom-sast-rules.md).

# updateCustomSastRules

Replaces the organization custom SAST rules configuration. A successful update removes active findings for deleted or disabled rules and requests an organization scan.

### Examples

{% tabs %}
{% tab title="GraphQL" %}

```graphql
mutation UpdateCustomSastRules($input: UpdateCustomSastRulesInput!) {
  updateCustomSastRules(input: $input) {
    success
    reasonFailed
  }
}
```

#### Variables

This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.

```json
{
  "input": {
    "enabled": true,
    "rules": [
      {
        "name": "Disallow eval",
        "issueName": "Unsafe use of eval",
        "severity": "high",
        "customRule": "rules:
  - id: javascript-eval
    languages:
      - javascript
    severity: WARNING
    message: Detect use of eval
    pattern: eval(...)",
        "customIssueDescription": "The code uses eval, which can execute arbitrary code.",
        "issueRecommendation": "Replace eval with safer parsing alternatives."
      }
    ]
  }
}
```

{% endtab %}

{% tab title="cURL" %}

```shell
curl -X POST \
https://api.cloud.ox.security/api/apollo-gateway \
-H 'Content-Type: application/json' \
-H 'Authorization: YOUR_API_TOKEN' \
-d '{
 "query": "mutation UpdateCustomSastRules($input: UpdateCustomSastRulesInput!) { updateCustomSastRules(input: $input) { success reasonFailed } }",
 "variables": {
    "input": {
      "enabled": true,
      "rules": [
        {
          "name": "Disallow eval",
          "issueName": "Unsafe use of eval",
          "severity": "high",
          "customRule": "rules:
  - id: javascript-eval
    languages:
      - javascript
    severity: WARNING
    message: Detect use of eval
    pattern: eval(...)",
          "customIssueDescription": "The code uses eval, which can execute arbitrary code.",
          "issueRecommendation": "Replace eval with safer parsing alternatives."
        }
      ]
    }
  }
}'
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const query = 'mutation UpdateCustomSastRules($input: UpdateCustomSastRulesInput!) { updateCustomSastRules(input: $input) { success reasonFailed } }';

fetch("https://api.cloud.ox.security/api/apollo-gateway", {
  method: "POST",
  headers: {
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  body: JSON.stringify({
    query: query,
    // This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    variables: {
      input: {
        enabled: true,
        rules: [
          {
            name: "Disallow eval",
            issueName: "Unsafe use of eval",
            severity: "high",
            customRule: "rules:
  - id: javascript-eval
    languages:
      - javascript
    severity: WARNING
    message: Detect use of eval
    pattern: eval(...)",
            customIssueDescription: "The code uses eval, which can execute arbitrary code.",
            issueRecommendation: "Replace eval with safer parsing alternatives."
          }
        ]
      }
    }
  })
})
.then(response => response.json())
.then(result => console.log(JSON.stringify(result, null, 2)))
.catch(error => console.error('Error:', error));
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

query = 'mutation UpdateCustomSastRules($input: UpdateCustomSastRulesInput!) { updateCustomSastRules(input: $input) { success reasonFailed } }'

response = requests.post(
  "https://api.cloud.ox.security/api/apollo-gateway",
  headers={
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  json={
    "query": query,
    # This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    "variables": {
      "input": {
        "enabled": true,
        "rules": [
          {
            "name": "Disallow eval",
            "issueName": "Unsafe use of eval",
            "severity": "high",
            "customRule": "rules:
  - id: javascript-eval
    languages:
      - javascript
    severity: WARNING
    message: Detect use of eval
    pattern: eval(...)",
            "customIssueDescription": "The code uses eval, which can execute arbitrary code.",
            "issueRecommendation": "Replace eval with safer parsing alternatives."
          }
        ]
      }
    }
  }
)

if response.status_code == 200:
    result = response.json()
    print(result)
else:
    print(f"Error: {response.status_code}")
    print(response.text)
```

{% endtab %}
{% endtabs %}

### Arguments

You can use the following argument(s) to customize your `updateCustomSastRules` mutation.

| Argument                                                                                                                                                                                       | Description                                                                                 | Supported fields                                                                                                                                                                    |
| ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| input [`UpdateCustomSastRulesInput!`](/api-documentation/api-reference/api--scan/types/inputs/update-custom-sast-rules-input.md) <mark style="color:red;background-color:red;">required</mark> | Custom SAST rules configuration to apply. Replaces the full rule list for the organization. | <p>enabled <code>Boolean!</code><br>rules <a href="/api-documentation/api-reference/api--scan/types/inputs/custom-sast-rule-input.md"><code>\[CustomSastRuleInput!]!</code></a></p> |

### Fields

Return type: [`UpdateCustomSastRulesResponse!`](/api-documentation/api-reference/api--scan/types/objects/update-custom-sast-rules-response.md)

You can use the following field(s) to specify what information your `updateCustomSastRules` mutation will return. Please note that some fields may have their own subfields.

| Field                 | Description                                                     | Supported fields |
| --------------------- | --------------------------------------------------------------- | ---------------- |
| success `Boolean!`    | Whether the custom SAST rules were saved successfully.          |                  |
| reasonFailed `String` | Validation or persistence failure reason when success is false. |                  |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ox.security/api-documentation/api-reference/api--scan/mutations/update-custom-sast-rules.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
